#Region-Splash-And-Icon---------------------------------------------------------
#AutoIt3Wrapper_Icon=C:\Documents and Settings\Milo\Desktop\data, assorted\autoit scripts\Double Click icon and logo\doubleclick.ico
#AutoIt3Wrapper_Res_LegalCopyright=Copyright 2009 by Milo Christiansen
#AutoIt3Wrapper_Res_Description=Warzone 2100 Mod Manager
#AutoIt3Wrapper_Res_Comment=BETA 1
#AutoIt3Wrapper_Res_Fileversion=3.0
#AutoIt3Wrapper_Res_Field=Company|Double Click Technologies
SplashImageOn("", @ScriptDir & "\Splash.gif", 400, 300, -1, -1, 1)
Sleep(2000)
SplashOff()
#EndRegion-Splash-And-Icon------------------------------------------------------
;Header-Start-------------------------------------------------------------------
;
; AutoIt Version: 3.3.0.0
; Author:         Milo Christiansen
;
; Script Function:
;		Warzone 2100 Mod Manager version 3.0
;
;Header-End---------------------------------------------------------------------

;Includes-Start-----------------------------------------------------------------

#include <MSG.au3> ;my custom msgbox library

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListBoxConstants.au3>
#include <StaticConstants.au3>
#include <TabConstants.au3>
#include <WindowsConstants.au3>

#include <GuiListBox.au3>

#include <WinAPI.au3>
#include <File.au3>

;Includes-End-------------------------------------------------------------------

;Options-Start------------------------------------------------------------------

#NoTrayIcon
Opt("MustDeclareVars", 1)

;Options-End--------------------------------------------------------------------

;General-Declerations-Start-----------------------------------------------------

Dim $winMain
Dim $winCreateSetting

Dim $hMainTab

Dim $hMod1
Dim $hChooseMod1
Dim $hMP1
Dim $hSP1
Dim $hGlobal1 
Dim $hlbl1
Dim $hUseMod1

Dim $hMod2
Dim $hChooseMod2
Dim $hMP2
Dim $hSP2
Dim $hGlobal2 
Dim $hlbl2
Dim $hUseMod2

Dim $hMod3
Dim $hChooseMod3
Dim $hMP3
Dim $hSP3
Dim $hGlobal3 
Dim $hlbl3
Dim $hUseMod3

Dim $hMod4
Dim $hChooseMod4
Dim $hMP4
Dim $hSP4
Dim $hGlobal4 
Dim $hlbl4
Dim $hUseMod4

Dim $hMod5
Dim $hChooseMod5
Dim $hMP5
Dim $hSP5
Dim $hGlobal5 
Dim $hlbl5
Dim $hUseMod5



Dim $hSettings
Dim $hCreateSetting
Dim $hSaveSetting 
Dim $hDeleteSetting
Dim $hChooseSetting

Dim $hMod1Display
Dim $hMod1State

Dim $hMod2Display
Dim $hMod2State

Dim $hMod3Display
Dim $hMod3State

Dim $hMod4Display
Dim $hMod4State

Dim $hMod5Display
Dim $hMod5State

Dim $hCurrentSettingFile

Dim $hOtherCommands

Dim $hRunWz

Dim $MsgGUI

Dim $CurrentSetting

Dim $GameDirPath
Dim $GameExePath

;Dim 
;Dim 

;General-Declerations-End-------------------------------------------------------

;CMD-Line-Handler-Start---------------------------------------------------------

If $CmdLineRaw <> "" Then
	If FileExists(StringTrimRight(StringTrimLeft($CmdLineRaw, 1), 1)) Then
		$CurrentSetting = StringTrimRight(StringTrimLeft($CmdLineRaw, 1), 1)
	EndIf
EndIf

;CMD-Line-Handler-End-----------------------------------------------------------

;Input-Start--------------------------------------------------------------------

_SETUP()

$GameDirPath = IniRead(@ScriptDir & "\Config.ini", "General", "GameDirPath", "ERROR")
$GameExePath = IniRead(@ScriptDir & "\Config.ini", "General", "GameExePath", "ERROR")

If $GameExePath = "ERROR" Or $GameDirPath = "ERROR" Then
	MsgBox(16, "Warzone 2100 Mod Manager", "ERROR in the Current Config File")
	Exit
EndIf

;Input-End----------------------------------------------------------------------

;Main-Script-Start--------------------------------------------------------------

;GUI
$winMain = GUICreate("Warzone 2100 Mod Manager", 584, 318, -1, -1)

$hMainTab = GUICtrlCreateTab(2, 2, 318, 255)

$hMod1 = GUICtrlCreateTabItem("Mod 1")
$hMP1 = GUICtrlCreateRadio("Multiplayer/Skirmish", 69, 226, 115, 17)
$hSP1 = GUICtrlCreateRadio("Campaign", 185, 226, 67, 17)
$hGlobal1 = GUICtrlCreateRadio("Global", 255, 226, 55, 17)
GUICtrlCreateLabel("Mod Scope", 11, 226, 59, 17)
$hChooseMod1 = GUICtrlCreateList("", 15, 59, 290, 162)
$hUseMod1 = GUICtrlCreateCheckbox("Use This Mod", 18, 38, 88, 17)

$hMod2 = GUICtrlCreateTabItem("Mod 2")
$hGlobal2 = GUICtrlCreateRadio("Global", 255, 226, 55, 17)
$hSP2 = GUICtrlCreateRadio("Campaign", 185, 226, 67, 17)
$hMP2 = GUICtrlCreateRadio("Multiplayer/Skirmish", 69, 226, 115, 17)
GUICtrlCreateLabel("Mod Scope", 11, 226, 59, 17)
$hChooseMod2 = GUICtrlCreateList("", 15, 59, 290, 162)
$hUseMod2 = GUICtrlCreateCheckbox("Use This Mod", 18, 38, 88, 17)

$hMod3 = GUICtrlCreateTabItem("Mod 3")
$hGlobal3 = GUICtrlCreateRadio("Global", 255, 226, 55, 17)
$hSP3 = GUICtrlCreateRadio("Campaign", 185, 226, 67, 17)
$hMP3 = GUICtrlCreateRadio("Multiplayer/Skirmish", 69, 226, 115, 17)
GUICtrlCreateLabel("Mod Scope", 11, 226, 59, 17)
$hChooseMod3 = GUICtrlCreateList("", 15, 59, 290, 162)
$hUseMod3 = GUICtrlCreateCheckbox("Use This Mod", 18, 38, 88, 17)

$hMod4 = GUICtrlCreateTabItem("Mod 4")
$hGlobal4 = GUICtrlCreateRadio("Global", 255, 226, 55, 17)
$hSP4 = GUICtrlCreateRadio("Campaign", 185, 226, 67, 17)
$hMP4 = GUICtrlCreateRadio("Multiplayer/Skirmish", 69, 226, 115, 17)
GUICtrlCreateLabel("Mod Scope", 11, 226, 59, 17)
$hChooseMod4 = GUICtrlCreateList("", 15, 59, 290, 162)
$hUseMod4 = GUICtrlCreateCheckbox("Use This Mod", 18, 38, 88, 17)

$hMod5 = GUICtrlCreateTabItem("Mod 5")
$hGlobal5 = GUICtrlCreateRadio("Global", 255, 226, 55, 17)
$hSP5 = GUICtrlCreateRadio("Campaign", 185, 226, 67, 17)
$hMP5 = GUICtrlCreateRadio("Multiplayer/Skirmish", 69, 226, 115, 17)
GUICtrlCreateLabel("Mod Scope", 11, 226, 59, 17)
$hChooseMod5 = GUICtrlCreateList("", 15, 59, 290, 162)
$hUseMod5 = GUICtrlCreateCheckbox("Use This Mod", 18, 38, 88, 17)

$hSettings = GUICtrlCreateTabItem("Setting Files")
$hCreateSetting = GUICtrlCreateButton("Create Setting File", 18, 33, 284, 25, 0)
$hSaveSetting = GUICtrlCreateButton("Save Settings To File", 18, 65, 284, 25, 0)
$hDeleteSetting = GUICtrlCreateButton("Delete Selected Setting File", 18, 97, 284, 25, 0)
$hChooseSetting = GUICtrlCreateList("", 18, 144, 284, 97)
GUICtrlCreateLabel("Choose Setting File", 18, 128, 95, 17)

GUICtrlSetState($hMod1, $GUI_SHOW)
GUICtrlCreateTabItem("")

GUICtrlCreateLabel("Mod 1 Current Setting", 324, 5, 107, 17)
$hMod1Display = GUICtrlCreateInput("", 324, 24, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod1State = GUICtrlCreateInput("", 479, 24, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Mod 2 Current Setting", 324, 50, 107, 17)
$hMod2Display = GUICtrlCreateInput("", 324, 67, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod2State = GUICtrlCreateInput("", 479, 67, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Mod 3 Current Setting", 324, 94, 107, 17)
$hMod3Display = GUICtrlCreateInput("", 324, 113, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod3State = GUICtrlCreateInput("", 479, 113, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Mod 4 Current Setting", 324, 139, 107, 17)
$hMod4Display = GUICtrlCreateInput("", 324, 156, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod4State = GUICtrlCreateInput("", 479, 156, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Mod 5 Current Setting", 324, 181, 107, 17)
$hMod5State = GUICtrlCreateInput("", 479, 198, 102, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
$hMod5Display = GUICtrlCreateInput("", 324, 198, 152, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Current Setting File", 324, 227, 93, 17)
$hCurrentSettingFile = GUICtrlCreateInput("", 417, 224, 166, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))

GUICtrlCreateLabel("Other Command Line Options", 61, 262, 142, 17)
$hOtherCommands = GUICtrlCreateInput("", 205, 261, 320, 21)

$hRunWz = GUICtrlCreateButton("Run Warzone 2100!",50,285,484,30)

GUISetState(@SW_SHOW)

_REFRESH_LIST_BOXES()

;Set Ctrl Inital States
GUICtrlSetState($hChooseMod1, $GUI_DISABLE)
GUICtrlSetState($hChooseMod2, $GUI_DISABLE)
GUICtrlSetState($hChooseMod3, $GUI_DISABLE)
GUICtrlSetState($hChooseMod4, $GUI_DISABLE)
GUICtrlSetState($hChooseMod5, $GUI_DISABLE)



;MSG loop
While 1
	$MsgGUI = GUIGetMsg()
	Switch $MsgGUI
		Case $GUI_EVENT_CLOSE
			Exit
		
		;Mod 1
		Case $hGlobal1
			_UPDATE_DATA_DISPLAY_1()
		Case $hSP1
			_UPDATE_DATA_DISPLAY_1()
		Case $hMP1
			_UPDATE_DATA_DISPLAY_1()
		Case $hChooseMod1
			_UPDATE_DATA_DISPLAY_1()
		Case $hUseMod1
			_ToggleMod1()
			_UPDATE_DATA_DISPLAY_1()
		
		;Mod 2
		Case $hGlobal2
			_UPDATE_DATA_DISPLAY_2()
		Case $hSP2
			_UPDATE_DATA_DISPLAY_2()
		Case $hMP2
			_UPDATE_DATA_DISPLAY_2()
		Case $hChooseMod2
			_UPDATE_DATA_DISPLAY_2()
		Case $hUseMod2
			_ToggleMod2()
			_UPDATE_DATA_DISPLAY_2()
			
		;Mod 3
		Case $hGlobal3
			_UPDATE_DATA_DISPLAY_3()
		Case $hSP3
			_UPDATE_DATA_DISPLAY_3()
		Case $hMP3
			_UPDATE_DATA_DISPLAY_3()
		Case $hChooseMod3
			_UPDATE_DATA_DISPLAY_3()
		Case $hUseMod3
			_ToggleMod3()
			_UPDATE_DATA_DISPLAY_3()
			
		;Mod 4
		Case $hGlobal4
			_UPDATE_DATA_DISPLAY_4()
		Case $hSP4
			_UPDATE_DATA_DISPLAY_4()
		Case $hMP4
			_UPDATE_DATA_DISPLAY_4()
		Case $hChooseMod4
			_UPDATE_DATA_DISPLAY_4()
		Case $hUseMod4
			_ToggleMod4()
			_UPDATE_DATA_DISPLAY_4()
			
		;Mod 5
		Case $hGlobal5
			_UPDATE_DATA_DISPLAY_5()
		Case $hSP5
			_UPDATE_DATA_DISPLAY_5()
		Case $hMP5
			_UPDATE_DATA_DISPLAY_5()
		Case $hChooseMod5
			_UPDATE_DATA_DISPLAY_5()
		Case $hUseMod5
			_ToggleMod5()
			_UPDATE_DATA_DISPLAY_5()
			
		;Settings
		Case $hCreateSetting
			_CREATE_SETTING_FILE()
			_UPDATE_DATA_DISPLAY_ALL()
		Case $hSaveSetting
			_SAVE_SETTINGS()
		Case $hDeleteSetting
			Local $RTN
			$RTN = MsgBox(36, "Delete Setting", "Delete setting file?")
			If $RTN = 6 Then
				FileDelete($CurrentSetting)
				MsgBox(0, "Delete Setting", "Setting file deleted.")
				_REFRESH_LIST_BOX_SETTING()
				_UPDATE_DATA_DISPLAY_SETTING()
			EndIf
		Case $hChooseSetting
			$CurrentSetting = (@ScriptDir & "\Setting Files\" & GUICtrlRead($hChooseSetting))
			_LOAD_SETTINGS()
			_UPDATE_DATA_DISPLAY_ALL()
		;Other
		Case $hRunWz
			_RUN()
	EndSwitch
WEnd


;Main-Script-End----------------------------------------------------------------

;Function-Decleration-Start-----------------------------------------------------

Func _RUN()

	Local $Mod1
	Local $Mod2
	Local $Mod3
	Local $Mod4
	Local $Mod5

	If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod1) <> "" Then
			If GUICtrlRead($hSP1) <> $GUI_CHECKED And GUICtrlRead($hMP1) <> $GUI_CHECKED And GUICtrlRead($hGlobal1) <> $GUI_CHECKED Then
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf

			Select
				Case GUICtrlRead($hSP1) = $GUI_CHECKED
					$Mod1 = ' --mod_ca "' & GUICtrlRead($hChooseMod1) & '"'
				Case GUICtrlRead($hMP1) = $GUI_CHECKED
					$Mod1 = ' --mod_mp "' & GUICtrlRead($hChooseMod1) & '"'
				Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
					$Mod1 = ' --mod "' & GUICtrlRead($hChooseMod1) & '"'
			EndSelect
		EndIf
	EndIf

	If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod2) <> "" Then
			If GUICtrlRead($hSP2) <> $GUI_CHECKED And GUICtrlRead($hMP2) <> $GUI_CHECKED And GUICtrlRead($hGlobal2) <> $GUI_CHECKED Then
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf

			Select
				Case GUICtrlRead($hSP2) = $GUI_CHECKED
					$Mod2 = ' --mod_ca "' & GUICtrlRead($hChooseMod2) & '"'
				Case GUICtrlRead($hMP2) = $GUI_CHECKED
					$Mod2 = ' --mod_mp "' & GUICtrlRead($hChooseMod2) & '"'
				Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
					$Mod2 = ' --mod "' & GUICtrlRead($hChooseMod2) & '"'
			EndSelect
		EndIf
	EndIf

	If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod3) <> "" Then
			If GUICtrlRead($hSP3) <> $GUI_CHECKED And GUICtrlRead($hMP3) <> $GUI_CHECKED And GUICtrlRead($hGlobal3) <> $GUI_CHECKED Then
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf

			Select
				Case GUICtrlRead($hSP3) = $GUI_CHECKED
					$Mod3 = ' --mod_ca "' & GUICtrlRead($hChooseMod3) & '"'
				Case GUICtrlRead($hMP3) = $GUI_CHECKED
					$Mod3 = ' --mod_mp "' & GUICtrlRead($hChooseMod3) & '"'
				Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
					$Mod3 = ' --mod "' & GUICtrlRead($hChooseMod3) & '"'
			EndSelect
		EndIf
	EndIf

	If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod4) <> "" Then
			If GUICtrlRead($hSP4) <> $GUI_CHECKED And GUICtrlRead($hMP4) <> $GUI_CHECKED And GUICtrlRead($hGlobal4) <> $GUI_CHECKED Then
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf

			Select
				Case GUICtrlRead($hSP4) = $GUI_CHECKED
					$Mod4 = ' --mod_ca "' & GUICtrlRead($hChooseMod4) & '"'
				Case GUICtrlRead($hMP4) = $GUI_CHECKED
					$Mod4 = ' --mod_mp "' & GUICtrlRead($hChooseMod4) & '"'
				Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
					$Mod4 = ' --mod "' & GUICtrlRead($hChooseMod4) & '"'
			EndSelect
		EndIf
	EndIf

	If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
		If GUICtrlRead($hChooseMod5) <> "" Then
			If GUICtrlRead($hSP5) <> $GUI_CHECKED And GUICtrlRead($hMP5) <> $GUI_CHECKED And GUICtrlRead($hGlobal5) <> $GUI_CHECKED Then
				MsgBox(48, "Warzone 2100 Mod Manager", "Please make sure that all selected mods are set to Multiplayer/Skirmish, Campaign, or Global")
				Return
			EndIf

			Select
				Case GUICtrlRead($hSP5) = $GUI_CHECKED
					$Mod5 = ' --mod_ca "' & GUICtrlRead($hChooseMod5) & '"'
				Case GUICtrlRead($hMP5) = $GUI_CHECKED
					$Mod5 = ' --mod_mp "' & GUICtrlRead($hChooseMod5) & '"'
				Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
					$Mod5 = ' --mod "' & GUICtrlRead($hChooseMod5) & '"'
			EndSelect
		EndIf
	EndIf

	;Run Warzone
	ShellExecute($GameExePath, $Mod1 & $Mod2 & $Mod3 & $Mod4 & $Mod5 & " " & StringStripWS(GUICtrlRead($hOtherCommands), 7))

	Exit

EndFunc   ;==>_RUN

Func _ToggleMod1()

	If GUICtrlRead($hUseMod1) = $GUI_UNCHECKED Then
		GUICtrlSetState($hChooseMod1, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod1, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod1

Func _ToggleMod2()

	If GUICtrlRead($hUseMod2) = $GUI_UNCHECKED Then
		GUICtrlSetState($hChooseMod2, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod2, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod2

Func _ToggleMod3()

	If GUICtrlRead($hUseMod3) = $GUI_UNCHECKED Then
		GUICtrlSetState($hChooseMod3, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod3, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod3

Func _ToggleMod4()

	If GUICtrlRead($hUseMod4) = $GUI_UNCHECKED Then
		GUICtrlSetState($hChooseMod4, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod4, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod4

Func _ToggleMod5()

	If GUICtrlRead($hUseMod5) = $GUI_UNCHECKED Then
		GUICtrlSetState($hChooseMod5, $GUI_DISABLE)
	Else
		GUICtrlSetState($hChooseMod5, $GUI_ENABLE)
	EndIf

EndFunc   ;==>_ToggleMod5

Func _UPDATE_DATA_DISPLAY_ALL()
	
	_UPDATE_DATA_DISPLAY_1()
	_UPDATE_DATA_DISPLAY_2()
	_UPDATE_DATA_DISPLAY_3()
	_UPDATE_DATA_DISPLAY_4()
	_UPDATE_DATA_DISPLAY_5()
	_UPDATE_DATA_DISPLAY_SETTING()
	
EndFunc

Func _UPDATE_DATA_DISPLAY_SETTING()
	
	GUICtrlSetData($hCurrentSettingFile,GUICtrlRead($hChooseSetting))
	
EndFunc

Func _UPDATE_DATA_DISPLAY_1()

	If GUICtrlRead($hUseMod1) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod1Display,"")
		GUICtrlSetData($hMod1State,"")
	Else
		GUICtrlSetData($hMod1Display,GUICtrlRead($hChooseMod1))
		Select 
			Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State,"Global")
			Case GUICtrlRead($hSP1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State,"Campaign")
			Case GUICtrlRead($hMP1) = $GUI_CHECKED
				If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then GUICtrlSetData($hMod1State,"Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_1

Func _UPDATE_DATA_DISPLAY_2()

	If GUICtrlRead($hUseMod2) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod2Display,"")
		GUICtrlSetData($hMod2State,"")
	Else
		GUICtrlSetData($hMod2Display,GUICtrlRead($hChooseMod2))
		Select 
			Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State,"Global")
			Case GUICtrlRead($hSP2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State,"Campaign")
			Case GUICtrlRead($hMP2) = $GUI_CHECKED
				If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then GUICtrlSetData($hMod2State,"Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_2

Func _UPDATE_DATA_DISPLAY_3()

	If GUICtrlRead($hUseMod3) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod3Display,"")
		GUICtrlSetData($hMod3State,"")
	Else
		GUICtrlSetData($hMod3Display,GUICtrlRead($hChooseMod3))
		Select 
			Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State,"Global")
			Case GUICtrlRead($hSP3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State,"Campaign")
			Case GUICtrlRead($hMP3) = $GUI_CHECKED
				If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then GUICtrlSetData($hMod3State,"Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_3

Func _UPDATE_DATA_DISPLAY_4()

	If GUICtrlRead($hUseMod4) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod4Display,"")
		GUICtrlSetData($hMod4State,"")
	Else
		GUICtrlSetData($hMod4Display,GUICtrlRead($hChooseMod4))
		Select 
			Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State,"Global")
			Case GUICtrlRead($hSP4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State,"Campaign")
			Case GUICtrlRead($hMP4) = $GUI_CHECKED
				If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then GUICtrlSetData($hMod4State,"Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_4

Func _UPDATE_DATA_DISPLAY_5()

	If GUICtrlRead($hUseMod5) = $GUI_UNCHECKED Then
		GUICtrlSetData($hMod5Display,"")
		GUICtrlSetData($hMod5State,"")
	Else
		GUICtrlSetData($hMod5Display,GUICtrlRead($hChooseMod5))
		Select 
			Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State,"Global")
			Case GUICtrlRead($hSP5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State,"Campaign")
			Case GUICtrlRead($hMP5) = $GUI_CHECKED
				If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then GUICtrlSetData($hMod5State,"Multiplayer/Skirmish")
		EndSelect
	EndIf

EndFunc   ;==>_UPDATE_DATA_DISPLAY_5

Func _REFRESH_LIST_BOXES()

	_GUICtrlListBox_BeginUpdate($hChooseMod1)
	_GUICtrlListBox_ResetContent($hChooseMod1)
	_GUICtrlListBox_AddDir($hChooseMod1, $GameDirPath & "\mods\campaign","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod1, $GameDirPath & "\mods\global","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod1, $GameDirPath & "\mods\multiplay","*.wz")
	_GUICtrlListBox_EndUpdate($hChooseMod1)

	_GUICtrlListBox_BeginUpdate($hChooseMod2)
	_GUICtrlListBox_ResetContent($hChooseMod2)
	_GUICtrlListBox_AddDir($hChooseMod2, $GameDirPath & "\mods\campaign","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod2, $GameDirPath & "\mods\global","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod2, $GameDirPath & "\mods\multiplay","*.wz")
	_GUICtrlListBox_EndUpdate($hChooseMod2)

	_GUICtrlListBox_BeginUpdate($hChooseMod3)
	_GUICtrlListBox_ResetContent($hChooseMod3)
	_GUICtrlListBox_AddDir($hChooseMod3, $GameDirPath & "\mods\campaign","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod3, $GameDirPath & "\mods\global","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod3, $GameDirPath & "\mods\multiplay","*.wz")
	_GUICtrlListBox_EndUpdate($hChooseMod3)

	_GUICtrlListBox_BeginUpdate($hChooseMod4)
	_GUICtrlListBox_ResetContent($hChooseMod4)
	_GUICtrlListBox_AddDir($hChooseMod4, $GameDirPath & "\mods\campaign","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod4, $GameDirPath & "\mods\global","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod4, $GameDirPath & "\mods\multiplay","*.wz")
	_GUICtrlListBox_EndUpdate($hChooseMod4)

	_GUICtrlListBox_BeginUpdate($hChooseMod5)
	_GUICtrlListBox_ResetContent($hChooseMod5)
	_GUICtrlListBox_AddDir($hChooseMod5, $GameDirPath & "\mods\campaign","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod5, $GameDirPath & "\mods\global","*.wz")
	_GUICtrlListBox_AddDir($hChooseMod5, $GameDirPath & "\mods\multiplay","*.wz")
	_GUICtrlListBox_EndUpdate($hChooseMod5)

	_REFRESH_LIST_BOX_SETTING()

EndFunc   ;==>_REFRESH_LIST_BOXES

Func _REFRESH_LIST_BOX_SETTING()
	
	_GUICtrlListBox_BeginUpdate($hChooseSetting)
	_GUICtrlListBox_ResetContent($hChooseSetting)
	_GUICtrlListBox_AddDir($hChooseSetting, @ScriptDir & "\Setting Files","*.set")
	_GUICtrlListBox_EndUpdate($hChooseSetting)
	_GUICtrlListBox_SelectString($hChooseSetting, StringTrimRight(StringTrimLeft($CurrentSetting, StringInStr($CurrentSetting, "\", 0, -1)), 1))
	
EndFunc

Func _LOAD_SETTINGS()

	Local $ModFile1
	Local $ModScope1
	Local $ModFile2
	Local $ModScope2
	Local $ModFile3
	Local $ModScope3
	Local $ModFile4
	Local $ModScope4
	Local $ModFile5
	Local $ModScope5

	GUICtrlSetData($hOtherCommands, IniRead($CurrentSetting, "General", "OtherCommands", ""))

	$ModFile1 = IniRead($CurrentSetting, "Setting1", "ModFile", "ERROR")
	$ModScope1 = IniRead($CurrentSetting, "Setting1", "ModScope", "ERROR")

	If $ModFile1 <> "ERROR" And $ModFile1 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod1)
		_GUICtrlListBox_SelectString($hChooseMod1, IniRead($CurrentSetting, "Setting1", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod1)
		GUICtrlSetState($hUseMod1, $GUI_CHECKED)
		GUICtrlSetState($hChooseMod1, $GUI_ENABLE)
		Switch $ModScope1
			Case "SP"
				GUICtrlSetState($hSP1, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP1, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal1, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod1, $GUI_UNCHECKED)
		GUICtrlSetState($hChooseMod1, $GUI_DISABLE)
	EndIf

	$ModFile2 = IniRead($CurrentSetting, "Setting2", "ModFile", "ERROR")
	$ModScope2 = IniRead($CurrentSetting, "Setting2", "ModScope", "ERROR")

	If $ModFile2 <> "ERROR" And $ModFile2 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod2)
		_GUICtrlListBox_SelectString($hChooseMod2, IniRead($CurrentSetting, "Setting2", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod2)
		GUICtrlSetState($hUseMod2, $GUI_CHECKED)
		GUICtrlSetState($hChooseMod2, $GUI_ENABLE)
		Switch $ModScope2
			Case "SP"
				GUICtrlSetState($hSP2, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP2, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal2, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod2, $GUI_UNCHECKED)
		GUICtrlSetState($hChooseMod2, $GUI_DISABLE)
	EndIf

	$ModFile3 = IniRead($CurrentSetting, "Setting3", "ModFile", "ERROR")
	$ModScope3 = IniRead($CurrentSetting, "Setting3", "ModScope", "ERROR")

	If $ModFile3 <> "ERROR" And $ModFile3 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod3)
		_GUICtrlListBox_SelectString($hChooseMod3, IniRead($CurrentSetting, "Setting3", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod3)
		GUICtrlSetState($hUseMod3, $GUI_CHECKED)
		GUICtrlSetState($hChooseMod3, $GUI_ENABLE)
		Switch $ModScope3
			Case "SP"
				GUICtrlSetState($hSP3, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP3, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal3, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod3, $GUI_UNCHECKED)
		GUICtrlSetState($hChooseMod3, $GUI_DISABLE)
	EndIf

	$ModFile4 = IniRead($CurrentSetting, "Setting4", "ModFile", "ERROR")
	$ModScope4 = IniRead($CurrentSetting, "Setting4", "ModScope", "ERROR")

	If $ModFile4 <> "ERROR" And $ModFile4 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod4)
		_GUICtrlListBox_SelectString($hChooseMod4, IniRead($CurrentSetting, "Setting4", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod4)
		GUICtrlSetState($hUseMod4, $GUI_CHECKED)
		GUICtrlSetState($hChooseMod4, $GUI_ENABLE)
		Switch $ModScope4
			Case "SP"
				GUICtrlSetState($hSP4, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP4, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal4, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod4, $GUI_UNCHECKED)
		GUICtrlSetState($hChooseMod4, $GUI_DISABLE)
	EndIf

	$ModFile5 = IniRead($CurrentSetting, "Setting5", "ModFile", "ERROR")
	$ModScope5 = IniRead($CurrentSetting, "Setting5", "ModScope", "ERROR")

	If $ModFile5 <> "ERROR" And $ModFile5 <> "" Then
		_GUICtrlListBox_BeginUpdate($hChooseMod5)
		_GUICtrlListBox_SelectString($hChooseMod5, IniRead($CurrentSetting, "Setting5", "ModFile", "ERROR"))
		_GUICtrlListBox_EndUpdate($hChooseMod5)
		GUICtrlSetState($hUseMod5, $GUI_CHECKED)
		GUICtrlSetState($hChooseMod5, $GUI_ENABLE)
		Switch $ModScope5
			Case "SP"
				GUICtrlSetState($hSP5, $GUI_CHECKED)
			Case "MP"
				GUICtrlSetState($hMP5, $GUI_CHECKED)
			Case "GLOBAL"
				GUICtrlSetState($hGlobal5, $GUI_CHECKED)
		EndSwitch
	Else
		GUICtrlSetState($hUseMod5, $GUI_UNCHECKED)
		GUICtrlSetState($hChooseMod5, $GUI_DISABLE)
	EndIf

	MsgBox(0, "Warzone 2100 Mod Manager", "Settings Loaded")

EndFunc   ;==>_LOAD_SETTINGS

Func _SAVE_SETTINGS()

		;Setting 1
		If GUICtrlRead($hUseMod1) = $GUI_CHECKED Then
			IniWrite($CurrentSetting, "Setting1", "ModFile", GUICtrlRead($hChooseMod1))
			Select
				Case GUICtrlRead($hSP1) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting1", "ModScope", "SP")
				Case GUICtrlRead($hMP1) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting1", "ModScope", "MP")
				Case GUICtrlRead($hGlobal1) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting1", "ModScope", "Global")
				Case Else
					IniWrite($CurrentSetting, "Setting1", "ModScope", "")
			EndSelect
		Else
			IniWrite($CurrentSetting, "Setting1", "ModFile", "")
			IniWrite($CurrentSetting, "Setting1", "ModScope", "")
		EndIf

		;Setting 2
		If GUICtrlRead($hUseMod2) = $GUI_CHECKED Then
			IniWrite($CurrentSetting, "Setting2", "ModFile", GUICtrlRead($hChooseMod2))
			Select
				Case GUICtrlRead($hSP2) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting2", "ModScope", "SP")
				Case GUICtrlRead($hMP2) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting2", "ModScope", "MP")
				Case GUICtrlRead($hGlobal2) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting2", "ModScope", "Global")
				Case Else
					IniWrite($CurrentSetting, "Setting2", "ModScope", "")
			EndSelect
		Else
			IniWrite($CurrentSetting, "Setting2", "ModFile", "")
			IniWrite($CurrentSetting, "Setting2", "ModScope", "")
		EndIf

		;Setting 3
		If GUICtrlRead($hUseMod3) = $GUI_CHECKED Then
			IniWrite($CurrentSetting, "Setting3", "ModFile", GUICtrlRead($hChooseMod3))
			Select
				Case GUICtrlRead($hSP3) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting3", "ModScope", "SP")
				Case GUICtrlRead($hMP3) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting3", "ModScope", "MP")
				Case GUICtrlRead($hGlobal3) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting3", "ModScope", "Global")
				Case Else
					IniWrite($CurrentSetting, "Setting3", "ModScope", "")
			EndSelect
		Else
			IniWrite($CurrentSetting, "Setting3", "ModFile", "")
			IniWrite($CurrentSetting, "Setting3", "ModScope", "")
		EndIf

		;Setting 4
		If GUICtrlRead($hUseMod4) = $GUI_CHECKED Then
			IniWrite($CurrentSetting, "Setting4", "ModFile", GUICtrlRead($hChooseMod4))
			Select
				Case GUICtrlRead($hSP4) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting4", "ModScope", "SP")
				Case GUICtrlRead($hMP4) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting4", "ModScope", "MP")
				Case GUICtrlRead($hGlobal4) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting4", "ModScope", "Global")
				Case Else
					IniWrite($CurrentSetting, "Setting4", "ModScope", "")
			EndSelect
		Else
			IniWrite($CurrentSetting, "Setting4", "ModFile", "")
			IniWrite($CurrentSetting, "Setting4", "ModScope", "")
		EndIf

		;Setting 5
		If GUICtrlRead($hUseMod5) = $GUI_CHECKED Then
			IniWrite($CurrentSetting, "Setting5", "ModFile", GUICtrlRead($hChooseMod5))
			Select
				Case GUICtrlRead($hSP5) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting5", "ModScope", "SP")
				Case GUICtrlRead($hMP5) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting5", "ModScope", "MP")
				Case GUICtrlRead($hGlobal5) = $GUI_CHECKED
					IniWrite($CurrentSetting, "Setting5", "ModScope", "Global")
				Case Else
					IniWrite($CurrentSetting, "Setting5", "ModScope", "")
			EndSelect
		Else
			IniWrite($CurrentSetting, "Setting5", "ModFile", "")
			IniWrite($CurrentSetting, "Setting5", "ModScope", "")
		EndIf

		;Other Commands
		IniWrite($CurrentSetting, "General", "OtherCommands", GUICtrlRead($hOtherCommands))
		
		MsgBox(0, "Warzone 2100 Mod Manager", "Setting Saved to Selected File")

EndFunc   ;==>_SAVE_SETTINGS


Func _CREATE_SETTING_FILE()
	
	Local $Blank
	Local $Save
	
	;GUI
	$winCreateSetting = GUICreate("Warzone 2100 Mod Manager", 304, 66, -1, -1)

	$Blank = GUICtrlCreateButton("Create Empty Setting File", 2, 2, 300, 30)
	$Save = GUICtrlCreateButton("Create Setting File With Currently Selected Mods", 2, 34, 300, 30)

	GUISetState()

	;MSG loop
	While 1
		$msgGUI = GUIGetMsg()
		Select
			
			Case $msgGUI = $GUI_EVENT_CLOSE
				
				ExitLoop
				
			Case $msgGUI = $Blank
				
				Local $RTN
				$RTN = InputBox("Create Setting", "Enter name for new setting file.", "", " M", 300, 80)
				
				If @error <> 1 Then
					_FileCreate(@ScriptDir & "\Setting Files\" & $RTN & ".set")
					MsgBox(0, "Create Setting", "Setting file Created.")
					$CurrentSetting = (@ScriptDir & "\Setting Files\" & $RTN & ".set")
					_REFRESH_LIST_BOX_SETTING()
					ExitLoop
				EndIf
				
			Case $msgGUI = $Save
				
				Local $RTN
				$RTN = InputBox("Create Setting", "Enter name for new setting file.", "", " M", 300, 80)
				
				If @error <> 1 Then
					_FileCreate(@ScriptDir & "\Setting Files\" & $RTN & ".set")
					MsgBox(0, "Create Setting", "Setting file Created.")
					$CurrentSetting = (@ScriptDir & "\Setting Files\" & $RTN & ".set")
					_SAVE_SETTINGS()
					_REFRESH_LIST_BOX_SETTING()
					_GUICtrlListBox_BeginUpdate($hChooseSetting)
					_GUICtrlListBox_SelectString($hChooseSetting, $RTN & ".set")
					_GUICtrlListBox_EndUpdate($hChooseSetting)
					
					ExitLoop
				EndIf
				
		EndSelect
	WEnd
	GUIDelete($winCreateSetting)
EndFunc

Func _SETUP()

	Local $Default
	Local $Custom
	Local $cdcRtn
	Local $SetupYN

	$SetupYN = IniRead(@ScriptDir & "\Config.ini", "General", "SetupYN", "ERROR")

	If $SetupYN = "N" Or FileExists(@ScriptDir & "\Config.ini") = 1 Then
		Return
	EndIf

	;GUI
	GUICreate("Warzone 2100 Mod Manager Setup", 550, 68, -1, -1)

	$Default = GUICtrlCreateButton("Click Here If You Have Installed ""Warzone2100.exe"" to ""%Program Files%\Warzone 2100"". (Default for 2.2.1)", 2, 2, 546, 30)
	$Custom = GUICtrlCreateButton("Click Here If Your .exe is NOT named ""Warzone2100.exe"" or is installed to a different path.", 2, 34, 546, 30)

	GUISetState()

	;MSG loop

	While 1

		$msgGUI = GUIGetMsg()

		Select

			Case $msgGUI = $GUI_EVENT_CLOSE
				Exit
			Case $msgGUI = $Default
				DirCreate(@ScriptDir & "\Setting Files")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameExePath", @ProgramFilesDir & "\Warzone 2100\warzone2100.exe")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameDirPath", @ProgramFilesDir & "\Warzone 2100")
				IniWrite(@ScriptDir & "\Config.ini", "General", "SetupYN", "N")
				Return

			Case $msgGUI = $Custom

				$cdcRtn = _WinAPI_GetOpenFileName("Warzone 2100 Mod Manager Setup", "EXE Files (*.exe)", @ProgramFilesDir)
				DirCreate(@ScriptDir & "\Setting Files")
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameExePath", $cdcRtn[1] & "\" & $cdcRtn[2])
				IniWrite(@ScriptDir & "\Config.ini", "General", "GameDirPath", $cdcRtn[1])
				IniWrite(@ScriptDir & "\Config.ini", "General", "SetupYN", "N")
				Return

		EndSelect

	WEnd

EndFunc   ;==>_SETUP

Func _GUICtrlListBox_AddDir($CtrlHandle,$Dir,$FileName)
	Local $test
	local $count = 1
	
	$test = _FileListToArray($Dir,$FileName,1)
	
	If @Error = 4  Then
		Return
	ElseIf @error <> 0 Then
		MSG_ERROR("ERROR  @error = " & @error)
		Return
	EndIf
	
	While $count <= $test[0]
		_GUICtrlListBox_AddString($CtrlHandle, $test[$count])
		$count += 1
	WEnd
	
EndFunc

;Function-Decleration-End-------------------------------------------------------